/*
 *  TOPPERS/A-RTEGEN
 *      Automotive Runtime Environment Generator
 *
 *  Copyright (C) 2013-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2013-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2013-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2013-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2013-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2013-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2013-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: EcuM_Callout.h 122 2015-07-17 01:31:28Z ertl-honda $
 */

#ifndef ECUM_CALLOUT_H
#define ECUM_CALLOUT_H

#include "Os.h"
#include "Rte_Main.h"
#include "sysmod/serial.h"
#include "sysmod/syslog.h"
#include "sysmod/banner.h"
#include "t_syslog.h"

#ifndef TOPPERS_NO_USE_COMSTACK
#include "Com.h"
#include "CanIf.h"
#include "Can.h"
#endif /* TOPPERS_NO_USE_COMSTACK */

LOCAL_INLINE void
EcuM_AL_DriverInitZero(void)
{
	syslog_initialize();
	syslog_msk_log(LOG_UPTO(LOG_INFO));
	InitSerial();
	print_banner();
}

#define ALARM_TICK_125US	1000U
#define ALARM_TICK_10MS		80000U
#define ALARM_TICK_20MS		160000U
#define ALARM_TICK_100MS	800000U

LOCAL_INLINE void
EcuM_BswStartupTwo(void)
{
	Std_ReturnType	ercd = E_OK;

#ifndef TOPPERS_NO_USE_COMSTACK
	/*
	 * COMåư
	 */
	Com_IpduGroupVector	vector_on;

	/* Can⥸塼 */
	Can_Init(NULL_PTR);

	/* CanIf⥸塼 */
	CanIf_Init(NULL_PTR);
	/* CanIf⥸塼륹ȥå */
	ercd = CanIf_SetControllerMode(0U, CANIF_CS_STARTED);
	if (ercd != E_OK) {
		syslog(LOG_NOTICE, "## CanIf_SetControllerMode returns E_NOT_OK !!");
	}
	ercd = CanIf_SetPduMode(0U, CANIF_SET_ONLINE);
	if (ercd != E_OK) {
		syslog(LOG_NOTICE, "## CanIf_SetPduMode returns E_NOT_OK !!");
	}

	/* Com⥸塼 */
	Com_Init(NULL_PTR);
	/* Com⥸塼륹ȥå */
	Com_SetIpduGroup(vector_on, 0, TRUE);
	Com_IpduGroupControl(vector_on, TRUE);
#endif /* TOPPERS_NO_USE_COMSTACK */

	/*
	 * ƥ顼൯ư
	 * (¾νλ˵ưΤ򤱤뤿ἫưưϤʤ)
	 */

#ifdef ECU_CBO_ALARM_125us
	ercd += SetRelAlarm(ECU_CBO_ALARM_125us, ALARM_TICK_125US, ALARM_TICK_125US);
#endif /* ECU_CBO_ALARM_125us */
#ifdef ECU_CBO_ALARM_10ms
	ercd += SetRelAlarm(ECU_CBO_ALARM_10ms, ALARM_TICK_10MS, ALARM_TICK_10MS);
#endif /* ECU_CBO_ALARM_10ms */
#ifdef ECU_CBO_ALARM_100ms
	ercd += SetRelAlarm(ECU_CBO_ALARM_100ms, ALARM_TICK_100MS, ALARM_TICK_100MS);
#endif /* ECU_CBO_ALARM_100ms */

#ifdef ECU_CB_ALARM_125us
	ercd += SetRelAlarm(ECU_CB_ALARM_125us, ALARM_TICK_125US, ALARM_TICK_125US);
#endif /* ECU_CB_ALARM_125us */
#ifdef ECU_CB_ALARM_10ms
	ercd += SetRelAlarm(ECU_CB_ALARM_10ms, ALARM_TICK_10MS, ALARM_TICK_10MS);
#endif /* ECU_CB_ALARM_10ms */
#ifdef ECU_CB_ALARM_20ms_SCHM
	ercd += SetRelAlarm(ECU_CB_ALARM_20ms_SCHM, ALARM_TICK_20MS, ALARM_TICK_20MS);
#endif /* ECU_CB_ALARM_20ms_SCHM */
#ifdef ECU_CB_ALARM_100ms
	ercd += SetRelAlarm(ECU_CB_ALARM_100ms, ALARM_TICK_100MS, ALARM_TICK_100MS);
#endif /* ECU_CB_ALARM_100ms */

#ifdef ECU_CO_ALARM_10ms
	ercd += SetRelAlarm(ECU_CO_ALARM_10ms, ALARM_TICK_10MS, ALARM_TICK_10MS);
#endif /* ECU_CO_ALARM_10ms */
#ifdef ECU_CO_ALARM_20ms_SCHM
	ercd += SetRelAlarm(ECU_CO_ALARM_20ms_SCHM, ALARM_TICK_20MS, ALARM_TICK_20MS);
#endif /* ECU_CO_ALARM_20ms_SCHM */
#ifdef ECU_CO_ALARM_100ms
	ercd += SetRelAlarm(ECU_CO_ALARM_100ms, ALARM_TICK_100MS, ALARM_TICK_100MS);
#endif /* ECU_CO_ALARM_100ms */

#ifdef ECU_COD_ALARM_10ms
	ercd += SetRelAlarm(ECU_COD_ALARM_10ms, ALARM_TICK_10MS, ALARM_TICK_10MS);
#endif /* ECU_CO_ALARM_10ms */
#ifdef ECU_COD_ALARM_20ms_SCHM
	ercd += SetRelAlarm(ECU_COD_ALARM_20ms_SCHM, ALARM_TICK_20MS, ALARM_TICK_20MS);
#endif /* ECU_CO_ALARM_20ms_SCHM */
#ifdef ECU_COD_ALARM_100ms
	ercd += SetRelAlarm(ECU_COD_ALARM_100ms, ALARM_TICK_100MS, ALARM_TICK_100MS);
#endif /* ECU_CO_ALARM_100ms */

#ifdef ECU_C_ALARM_10ms
	ercd += SetRelAlarm(ECU_C_ALARM_10ms, ALARM_TICK_10MS, ALARM_TICK_10MS);
#endif /* ECU_C_ALARM_10ms */
#ifdef ECU_C_ALARM_20ms_SCHM
	ercd += SetRelAlarm(ECU_C_ALARM_20ms_SCHM, ALARM_TICK_20MS, ALARM_TICK_20MS);
#endif /* ECU_C_ALARM_20ms_SCHM */
#ifdef ECU_C_ALARM_100ms
	ercd += SetRelAlarm(ECU_C_ALARM_100ms, ALARM_TICK_100MS, ALARM_TICK_100MS);
#endif /* ECU_C_ALARM_100ms */

#ifdef ECU_B_ALARM_125us
	ercd += SetRelAlarm(ECU_B_ALARM_125us, ALARM_TICK_125US, ALARM_TICK_125US);
#endif /* ECU_B_ALARM_125us */
#ifdef ECU_B_ALARM_20ms_SCHM
	ercd += SetRelAlarm(ECU_B_ALARM_20ms_SCHM, ALARM_TICK_20MS, ALARM_TICK_20MS);
#endif /* ECU_B_ALARM_20ms_SCHM */
#ifdef ECU_B_ALARM_100ms
	ercd += SetRelAlarm(ECU_B_ALARM_100ms, ALARM_TICK_100MS, ALARM_TICK_100MS);
#endif /* ECU_B_ALARM_100ms */

#ifdef ECU_O_ALARM_10ms
	ercd += SetRelAlarm(ECU_O_ALARM_10ms, ALARM_TICK_10MS, ALARM_TICK_10MS);
#endif /* ECU_O_ALARM_10ms */
#ifdef ECU_O_ALARM_20ms_SCHM
	ercd += SetRelAlarm(ECU_O_ALARM_20ms_SCHM, ALARM_TICK_20MS, ALARM_TICK_20MS);
#endif /* ECU_O_ALARM_20ms_SCHM */
#ifdef ECU_O_ALARM_100ms
	ercd += SetRelAlarm(ECU_O_ALARM_100ms, ALARM_TICK_100MS, ALARM_TICK_100MS);
#endif /* ECU_O_ALARM_100ms */

#ifdef ECU_OD_ALARM_10ms
	ercd += SetRelAlarm(ECU_OD_ALARM_10ms, ALARM_TICK_10MS, ALARM_TICK_10MS);
#endif /* ECU_OD_ALARM_10ms */
#ifdef ECU_OD_ALARM_20ms_SCHM
	ercd += SetRelAlarm(ECU_OD_ALARM_20ms_SCHM, ALARM_TICK_20MS, ALARM_TICK_20MS);
#endif /* ECU_OD_ALARM_20ms_SCHM */
#ifdef ECU_OD_ALARM_100ms
	ercd += SetRelAlarm(ECU_OD_ALARM_100ms, ALARM_TICK_100MS, ALARM_TICK_100MS);
#endif /* ECU_OD_ALARM_100ms */

	/* 1ĤǤ⥨顼зٹɽ */
	if (ercd != E_OK) {
		syslog(LOG_NOTICE, "## SetRelAlarm returns E_NOT_OK !!");
	}
}

LOCAL_INLINE void
EcuM_ApplicationStartupTwo(void)
{
	/* RTEν */
	Rte_Start();
}

/* BSW塼̤ѻϥ֤Ѱ */
#ifdef TOPPERS_NO_USE_SCHM
void SchM_Init(void)
{
}
#endif /* TOPPERS_NO_USE_SCHM */

#endif /* ECUM_CALLOUT_H */
